<template>
  <div
    v-if="isAdmin!=null"
    class="container-fluid"
  >
    <h1>
      <users-icon />
      Modifier une équipe
    </h1>
    <hr>
    <div
      class="row"
    >
      <div
        class="col-md-12"
        style="margin-bottom: 1vh;"
      >
        <input
          class="btn btn-primary"
          type="button"
          value="Retour"
          @click="$router.push({'path':'/admin/accueil?tab=2'})"
        >
      </div>
      <form
        id="teamForm"
        novalidate="novalidate"
      >
        <div class="row">
          <div class="col-xs-12 col-md-6">
            <div class="form-group required">
              <label
                for="description"
              >Nom&nbsp;:</label>
              <input
                id="description"
                v-model="team.description"
                name="description"
                type="description"
                class="form-control"
                required="required"
              >
            </div>
          </div>
          <div
            class="row"
            style="margin-top: 1em;"
          >
            <div
              class="col-xs-12"
              style="display: flex; flex-direction: column;"
            >
              <label style="text-align: center;">Domaine(s)</label>
              <el-transfer
                v-model="selectedBusinesses"
                style="margin: auto; width: 100%;"
                :data="availableBusinesses"
                :titles="['Disponible(s)', 'Autorisée(s)']"
                :props="{
                  key: 'id',
                  label: 'email'
                }"
                filterable
                :filter-method="filterBusinessesMethod"
                filter-placeholder="Rechercher"
              />
            </div>
          </div>
          <br>
          <div
            class="row"
            style="margin-top: 1em;"
          >
            <div
              class="col-xs-12"
              style="display: flex; flex-direction: column;"
            >
              <label style="text-align: center;">Gestionnaires(s)</label>
              <el-transfer
                v-model="selectedManagers"
                style="margin: auto; width: 100%;"
                :data="availableManagers"
                :titles="['Disponible(s)', 'Autorisée(s)']"
                :props="{
                  key: 'id',
                  label: 'email'
                }"
                filterable
                :filter-method="filterManagersMethod"
                filter-placeholder="Rechercher"
              />
            </div>
          </div>
          <br>
        </div>
        <div class="row">
          <div
            class="form-group btn-list"
          >
            <input
              class="btn btn-primary"
              :disabled="submitDisabled"
              type="submit"
              value="Modifier l'équipe"
              @click="performUpdateTeam()"
            >
          </div>
        </div>
      </form>
    </div>
  </div>
  <div
    v-else
  >
    Vous n'avez pas la permission requise pour afficher ces informations.
  </div>
</template>

<script>
import UsersIcon from "../../../components/Icon/UsersIcon";
import {mapActions, mapGetters} from "vuex";
import VanillaToasts from "vanillatoasts";

export default {
  name: "AdminEditTeam",
  components: {UsersIcon},
  data() {
    return {
      selectedBusinesses: [],
      availableBusinesses: [],
      selectedManagers: [],
      availableManagers: [],
      validator: null,
      description: '',
    }
  },
  computed: {
    ...mapGetters([
      'isAdmin',
      'isLoading',
      'managers',
      'businesses',
      'team'
    ]),
    submitDisabled: function () {
      return this.isLoading || this.team.description.length === 0;
    },
  },
  created() {
    this.fetchTeam(this.$route.params.id)
      .then((team) => {
        team.businesses.forEach(business => {
          this.selectedBusinesses.push(business.id)
        })
        team.managers.forEach(manager => {
          this.selectedManagers.push(manager.id)
        })
      })
    this.fetchBusinesses().then(() => {
      this.businesses.forEach(business => {
        this.availableBusinesses.push(business)
      })
    })
    this.fetchManagers().then(() => {
      this.managers.forEach(manager => {
        this.availableManagers.push(manager)
      })
    })
  },
  mounted() {
    this.validator = $('#teamForm').submit(function (e) {
      e.preventDefault();
    }).validate({
      rules: {
        description: {
          required: true,
          maxlength: 250,
        }
      },
      errorElement: 'em',
      errorPlacement: function (error, element) {
        // Add the `help-block` class to the error element
        error.addClass('help-block');

        if (element.prop("type") === 'checkbox') {
          error.insertAfter(element.parent('label'));
        } else {
          error.insertAfter(element);
        }
      },
      highlight: function (element) {
        $(element).parents(".form-group").addClass("has-error").removeClass("has-success");
      },
      unhighlight: function (element) {
        $(element).parents(".form-group").addClass("has-success").removeClass("has-error");
      }
    });
  },
  methods: {
    ...mapActions([
      'fetchBusinesses',
      'addManager',
      'addBusiness',
      'removeManager',
      'removeBusiness',
      'updateTeam',
      'loadingStarts',
      'loadingEnds',
      'fetchManagers',
      'fetchTeams',
      'fetchTeam'
    ]),
    async removeTeamManagers(team) {
      for (const manager of team.managers) {
        if (!this.selectedManagers.find((selectedManager) => {
          return manager.id === selectedManager
        })) {
          await this.removeManager({
            teamId: team.id,
            managerId: manager.id
          })
        }
      }
    },
    async addTeamManagers(team) {
      for (const selectedManager of this.selectedManagers) {
        if (!team.managers.find((manager) => {
          return manager.id === selectedManager
        })) {
          await this.addManager({
            teamId: team.id,
            managerId: selectedManager
          })
        }
      }
    },
    async removeTeamBusinesses(team) {
      for (const business of team.businesses) {
        if (!this.selectedBusinesses.find((selectedBusiness) => {
          return business.id === selectedBusiness
        })) {
          await this.removeBusiness({
            teamId: team.id,
            businessId: business.id
          })
        }
      }
    },
    async addTeamBusinesses(team) {
      for (const selectedBusiness of this.selectedBusinesses) {
        if (!team.businesses.find((business) => {
          return business.id === selectedBusiness
        })) {
          await this.addBusiness({
            teamId: team.id,
            businessId: selectedBusiness
          })
        }
      }
    },
    performUpdateTeam() {
      if ($("#teamForm").valid()) {
        this.loadingStarts()
        this.updateTeam(this.team).then((team) => {
          this.removeTeamManagers(team).then(() => {
            this.addTeamManagers(team).then(() => {
              this.removeTeamBusinesses(team).then(() => {
                this.addTeamBusinesses(team).then(() => {
                  this.fetchTeams()
                })
              })
            }).then(() => {
              VanillaToasts.create({
                title: 'Edition équipe',
                text: 'Équipe mise à jour succès.',
                type: 'success',
                timeout: 10000,
              });
              this.loadingEnds()
              this.$router.push({path: '/admin/accueil?tab=2'})
            })
          })
        })
      }
    },
    filterBusinessesMethod(query, item) {
      return item.email.toLowerCase().indexOf(query.toLowerCase()) > -1;
    },
    filterManagersMethod(query, item) {
      return item.email.toLowerCase().indexOf(query.toLowerCase()) > -1;
    }
  }
}
</script>

<style scoped>

</style>